--criação de tabelas

CREATE TABLE Proprietario OF tp_proprietario (
	CPF PRIMARY KEY,
	nome NOT NULL,
	profissao NOT NULL
) NESTED TABLE ref_empresa STORE AS tb_ref_empresa;

CREATE TABLE Grupo OF tp_grupo (
	codigo PRIMARY KEY,
	nome NOT NULL,
	descLocacao NOT NULL
) NESTED TABLE ref_empresa STORE AS tb_ref_empresa_g;

CREATE TABLE Empresa OF tp_empresa (
	CNPJ PRIMARY KEY,
	nome NOT NULL,
	areaAtuacao NOT NULL,
	ref_proprietario WITH ROWID REFERENCES Proprietario,
	ref_grupo WITH ROWID REFERENCES Grupo
) NESTED TABLE ref_empregados STORE AS tb_ref_empregados_e, NESTED TABLE ref_aluga STORE AS tb_ref_aluga;

CREATE TABLE Empregado of tp_empregado (
	nivelAcesso NOT NULL,
	PRIMARY KEY (CNPJ, numPessoal),
	ref_empresa WITH ROWID REFERENCES Empresa
) NESTED TABLE ref_acessa STORE AS tb_ref_acessa_e;

CREATE TABLE LocalComp of tp_local (
	codigo PRIMARY KEY,
	tipo NOT NULL,
	precoAluguel NOT NULL,
	nMinAcesso NOT NULL
) NESTED TABLE localSaida STORE AS tb_saida, NESTED TABLE localChegada STORE AS tb_chegada, NESTED TABLE ref_aluga STORE AS tb_ref_aluga_l, NESTED TABLE ref_acessa STORE AS tb_ref_acessa_l;

CREATE TABLE Funcionario OF tp_funcionario (
	CPF PRIMARY KEY,
	cTrabalho UNIQUE NOT NULL,
	nome NOT NULL,
	salario NOT NULL,
	funcao NOT NULL
);

--todos os atributos de Funcionario também estão em Administrador
CREATE TABLE Administrador OF tp_administrador (
	CPF PRIMARY KEY,
	cTrabalho UNIQUE NOT NULL,
	nome NOT NULL,
	salario NOT NULL,
	funcao NOT NULL
) NESTED TABLE ref_aluga STORE AS tb_ref_aluga_a;
