--criação de tipos

CREATE OR REPLACE TYPE tp_VA_telefones AS VARRAY(5) OF VARCHAR(13); --(__)____-____; máximo de 5 telefones
/

CREATE OR REPLACE TYPE tp_endereco AS OBJECT (
	logradouro	VARCHAR2(50),
	numero		NUMBER,
	complemento VARCHAR2(20),
	bairro 		VARCHAR2(20),
	cidade 		VARCHAR2(20),
	estado 		VARCHAR2(20)
);
/

CREATE OR REPLACE TYPE tp_empresa;
/
--Em qualquer relacionamento, é necessário colocar referências dos dois lados (COBRADO NA PROVA). Por exemplo, no relacionamento entre Empresa e Proprietário, a Empresa precisa ter uma referência para o seu Proprietário, e o Proprietário precisa ter uma lista de referências, uma para cada Empresa. Como um precisa do outro e um precisa ser criado antes, nós "mencionamos" Empresa, sem definir como objeto, apenas para "guardar espaço". Mais adiante, nós recriamos Empresa, dessa vez definindo todos os atributos do tipo.
CREATE OR REPLACE TYPE tp_NT_ref_empresa AS TABLE OF REF tp_empresa;
/
--lista de empresas (nested table)

CREATE OR REPLACE TYPE tp_proprietario AS OBJECT (
	CPF 		NUMBER,
	nome		VARCHAR2(50),
	profissao	VARCHAR2(20),
	telefones	tp_VA_telefones,
	ref_empresa tp_NT_ref_empresa
);
/

CREATE OR REPLACE TYPE tp_grupo AS OBJECT (
	codigo		NUMBER,
	nome		VARCHAR2(50),
	descLocacao DECIMAL (9,2),
	ref_empresa tp_NT_ref_empresa
);
/

CREATE OR REPLACE TYPE tp_local;
/

--primeira unidade do ternário Aluga (haverá uma unidade para cada uma das entidades participantes)
CREATE OR REPLACE TYPE tp_aluga_administrador AS OBJECT (
	ref_empresa REF tp_empresa,
	ref_local REF tp_local,
	dataInicio DATE,
	dataTermino DATE
);
/

CREATE OR REPLACE TYPE tp_NT_aluga_administrador AS TABLE OF tp_aluga_administrador;
/

CREATE OR REPLACE TYPE tp_funcionario AS OBJECT (
	CPF 		NUMBER,
	cTrabalho	NUMBER,
	nome		VARCHAR2(50),
	salario		DECIMAL(7,2),
	endereco	tp_endereco,
	funcao		VARCHAR2(20),
	telefones	tp_VA_telefones
) NOT FINAL;
/

CREATE OR REPLACE TYPE tp_administrador UNDER tp_funcionario (
	ref_aluga	tp_NT_aluga_administrador
);
/

--demais unidades do relacionamento Aluga
CREATE OR REPLACE TYPE tp_aluga_empresa AS OBJECT (
	ref_administrador REF tp_administrador,
	ref_local REF tp_local,
	dataInicio DATE,
	dataTermino DATE
);
/

CREATE OR REPLACE TYPE tp_NT_aluga_empresa AS TABLE OF tp_aluga_empresa;
/

CREATE OR REPLACE TYPE tp_aluga_local AS OBJECT (
	ref_administrador REF tp_administrador,
	ref_empresa REF tp_empresa,
	dataInicio DATE,
	dataTermino DATE
);
/

CREATE OR REPLACE TYPE tp_NT_aluga_local AS TABLE OF tp_aluga_local;
/

--criação de Empregado, para que possamos criar Empresa.
CREATE OR REPLACE TYPE tp_empregado;
/
CREATE OR REPLACE TYPE tp_NT_ref_empregado AS TABLE OF REF tp_empregado;
/
--Agora, recriamos Empresa como objeto, com todas as referências que faltavam.
CREATE OR REPLACE TYPE tp_empresa AS OBJECT (
	CNPJ			NUMBER,
	nome			VARCHAR2(50),
	areaAtuacao 	VARCHAR2(20),
	endereco 		tp_endereco,
	ref_proprietario REF tp_proprietario,
	ref_grupo		REF tp_grupo,
	ref_empregados	tp_NT_ref_empregado,
	ref_aluga		tp_NT_aluga_empresa
);
/

--preparando para Acessa
CREATE OR REPLACE TYPE tp_acessa_empregado AS OBJECT (
	ref_local REF tp_local,
	dataHora DATE
);
/

CREATE OR REPLACE TYPE tp_NT_acessa_empregado AS TABLE OF tp_acessa_empregado;
/

CREATE OR REPLACE TYPE tp_acessa_local AS OBJECT (
	ref_empregado REF tp_empregado,
	dataHora DATE
);
/

CREATE OR REPLACE TYPE tp_NT_acessa_local AS TABLE OF tp_acessa_local;
/

CREATE OR REPLACE TYPE tp_empregado AS OBJECT (
	CNPJ			NUMBER,
	numPessoal		NUMBER,
	nivelAcesso 	CHAR(1),
	ref_empresa		REF tp_empresa,
	ref_acessa		tp_NT_acessa_empregado 
);
/

--para transporte

CREATE OR REPLACE TYPE tp_ref_transporte AS OBJECT (
	lugar REF tp_local,
	meio VARCHAR2(20)
);
/
CREATE OR REPLACE TYPE tp_NT_ref_transporte AS TABLE OF tp_ref_transporte;
/

CREATE OR REPLACE TYPE tp_VA_servicos AS VARRAY(10) OF VARCHAR2(30);
/

CREATE OR REPLACE TYPE tp_localizacao AS OBJECT (
	setor 	VARCHAR2(20),
	numero 	NUMBER
);
/

CREATE OR REPLACE TYPE tp_local AS OBJECT (
	codigo			NUMBER,
	tipo			VARCHAR2(20),
	precoAluguel	DECIMAL(9,2),
	nMinAcesso		CHAR(1),
	localizacao		tp_localizacao,
	servicos		tp_VA_servicos,
	localChegada	tp_NT_ref_transporte,
	localSaida		tp_NT_ref_transporte,
	ref_aluga		tp_NT_aluga_local,
	ref_acessa		tp_NT_acessa_local
);
/
